This site contains documentation for the `messageformat2`, a Python library
which implements the [Unicode Message Format 2.0
specification](https://www.unicode.org/reports/tr35/tr35-72/tr35-messageFormat.html).

Message Format 2.0 (MF2) is a new iteration of Message Format which aims to be
more expressive and flexible than both Message Format 1.0 and, in the context of
Python, gettext.

If you would like to learn more about MF2 itself head over to the [Unicode technical
specification](https://www.unicode.org/reports/tr35/tr35-72/tr35-messageFormat.html).

## Features

The `messageformat2` library includes:

- A message parser and a formatter
- Several builtin formatters and selectors described by the
  [spec](https://www.unicode.org/reports/tr35/tr35-72/tr35-messageFormat.html#function-registry)
  and the possibility to write custom formatters/selectors
- Helper classes to inspect and transform the message [data
  model](https://www.unicode.org/reports/tr35/tr35-72/tr35-messageFormat.html#interchange-data-model)

### Work in progress

- Message extraction and loading - This will be provided once a format for MF2
  [message resources](https://github.com/eemeli/message-resource-wg) is
  standardized.

## Table Of Contents

1. [Tutorials](tutorials.md)
2. [How-To Guides](how-to-guides.md)
3. [Reference](reference.md)
4. [Explanation](explanation.md)

Quickly find what you're looking for depending on your use case by looking at
the different pages.
